#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>

extern void __chkabort(void);
extern int __fflush(FILE *stream);

size_t fwrite(void *ptr,size_t size,size_t nmemb,FILE *stream)
{
  signed long subsize;
  unsigned long total;
  unsigned char *b;
  __chkabort();
  if (!(total=size*nmemb))
    return 0;
  b=(unsigned char *)ptr;
  if(stream->flags&64) /* Error on stream */
  { errno=EPERM;
    return 0; }
  if(stream->flags&8)
  { if(__fflush(stream))
      return 0;
  }else if(stream->flags&4)
  {
    stream->incount=0; /* throw away input buffer */
    stream->tmpp=NULL;
    stream->flags&=~4;
  }
  while(total)
  { /* write buffer */
    if((subsize=write(stream->file,b,total))<0)
    {
      stream->flags|=64; /* error flag */
      break;
    }
    total=total-subsize;
    b=b+subsize;
  }
  return (b-(unsigned char *)ptr)/size;
}
